' BASS_CONFIG_GVOL_STREAM
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                  ZWP                                     |
'|                       (Zapsolution Window Plugin)                        |
'|                                                                          |
'|                          OpenGL + Audio player                           |
'|                                                                          |
'|                BASS 2.4 copyright (c) 1999-2014 Ian Luck.                |
'|                             www.un4seen.com                              |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                         copyright(c) 2007-2014                           |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 00-06-2007 (MM-DD-YYYY)            |
'|                        Last revised : 01-02-2014 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "ZWP.exe"

MACRO const = MACRO

const NULL                                           = 0
const WINAPI                                         = 1
const NM_FIRST                                       = 0
const NM_AUDIOCOMPLETION                             = NM_FIRST - 80
const WM_SETTEXT                                     = &HC
const IDC_ARROW                                      = 32512&
const MAX_PATH                                       = 260
const CCHDEVICENAME                                  = 32
const CCHFORMNAME                                    = 32
const PFD_TYPE_RGBA                                  = 0
const PFD_DOUBLEBUFFER                               = &H00000001
const PFD_DRAW_TO_WINDOW                             = &H00000004
const PFD_DRAW_TO_BITMAP                             = &H00000008
const PFD_SUPPORT_OPENGL                             = &H00000020
const SW_SHOW                                        = 5
const WM_DESTROY                                     = &H2
const WM_SIZE                                        = &H5
const WM_CLOSE                                       = &H10
const WM_TIMER                                       = &H113
const WM_DEVICECHANGE                                = &H219
const WM_WINDOWPOSCHANGING                           = &H46
const WS_POPUP                                       = &H80000000
const WS_VISIBLE                                     = &H10000000
const WS_EX_TOOLWINDOW                               = &H00000080
const WM_NOTIFY                                      = &H4E
const CS_VREDRAW                                     = &H1
const CS_HREDRAW                                     = &H2
const SM_CXSCREEN                                    = 0
const SM_CYSCREEN                                    = 1
const MONITOR_DEFAULTTONEAREST                       = &H00000002
const HKEY_CURRENT_USER                              = &H80000001???
const HKEY_LOCAL_MACHINE                             = &H80000002???
const GL_DEPTH_BUFFER_BIT                            = &H00000100
const GL_COLOR_BUFFER_BIT                            = &H00004000
const GL_LIST_BIT                                    = &H00020000
const GL_LINES                                       = &H0001
const GL_TRIANGLE_FAN                                = &H0006
const GL_UNSIGNED_BYTE                               = &H1401
const GL_FRONT_AND_BACK                              = &H0408
const GL_LIGHTING                                    = &H0B50
const GL_COLOR_MATERIAL                              = &H0B57
const GL_DEPTH_TEST                                  = &H0B71
const GL_NORMALIZE                                   = &H0BA1
const GL_ALPHA_TEST                                  = &H0BC0
const GL_BLEND                                       = &H0BE2
const GL_TEXTURE_2D                                  = &H0DE1
const GL_LIGHT0                                      = &H4000
const GL_LIGHT1                                      = &H4001
const GL_LIGHT2                                      = &H4002
const GL_LIGHT3                                      = &H4003
const GL_LIGHT4                                      = &H4004
const GL_LIGHT5                                      = &H4005
const GL_LIGHT6                                      = &H4006
const GL_LIGHT7                                      = &H4007
const GL_DIFFUSE                                     = &H1201
const GL_SPECULAR                                    = &H1202
const GL_SHININESS                                   = &H1601
const GL_MODELVIEW                                   = &H1700
const GL_PROJECTION                                  = &H1701
const GL_SMOOTH                                      = &H1D01

type WINDOWPOS
    hWnd as DWORD
    hWndInsertAfter as DWORD
    x as long
    y as long
    cx as long
    cy as long
    flags as DWORD
end type

type NMHDR
    hwndFrom as DWORD
    idfrom as DWORD
    code as long    ' used for messages, so needs to be LONG, not DWORD...
end type

type RECT
    nLeft as long
    nTop as long
    nRight as long
    nBottom as long
end type

type MONITORINFO
    cbSize as DWORD
    rcMonitor as RECT
    rcWork as RECT
    dwFlags as DWORD
end type

type POINTAPI
    x as long
    y as long
end type

type SIZEL
    cx as long
    cy as long
end type

type tagMSG
    hwnd as DWORD
    message as DWORD
    wParam as long
    lParam as long
    time as DWORD
    pt as POINTAPI
end type

type OVERLAPPED
    Internal as DWORD
    InternalHigh as DWORD
    offset as DWORD
    OffsetHigh as DWORD
    hEvent as DWORD
end type

type SECURITY_ATTRIBUTES
    nLength as DWORD
    lpSecurityDescriptor as long
    bInheritHandle as long
end type

type FILETIME
    dwLowDateTime as DWORD
    dwHighDateTime as DWORD
end type

type WNDCLASSEX
    cbSize as DWORD
    STYLE as DWORD
    lpfnWndProc as long
    cbClsExtra as long
    cbWndExtra as long
    hInstance as DWORD
    hIcon as DWORD
    hCursor as DWORD
    hbrBackground as DWORD
    lpszMenuName as ASCIIZ PTR
    lpszClassName as ASCIIZ PTR
    hIconSm as DWORD
end type

type WIN32_FIND_DATA
    dwFileAttributes as DWORD
    ftCreationTime as FILETIME
    ftLastAccessTime as FILETIME
    ftLastWriteTime as FILETIME
    nFileSizeHigh as DWORD
    nFileSizeLow as DWORD
    dwReserved0 as DWORD
    dwReserved1 as DWORD
    cFileName as ASCIIZ * MAX_PATH
    cAlternateFileName as ASCIIZ * 14
end type

type BITMAP
    bmType as long
    bmWidth as long
    bmHeight as long
    bmWidthBytes as long
    bmPlanes as WORD
    bmBitsPixel as WORD
    bmBits as BYTE PTR
end type

type RGBQUAD
    rgbBlue as BYTE
    rgbGreen as BYTE
    rgbRed as BYTE
    rgbReserved as BYTE
end type

type BITMAPINFOHEADER
    biSize as DWORD
    biWidth as long
    biHeight as long
    biPlanes as WORD
    biBitCount as WORD
    biCompression as DWORD
    biSizeImage as DWORD
    biXPelsPerMeter as long
    biYPelsPerMeter as long
    biClrUsed as DWORD
    biClrImportant as DWORD
end type

type BITMAPINFO
    bmiHeader as BITMAPINFOHEADER
    bmiColors as long
end type

type PIXELFORMATDESCRIPTOR
    nSize as WORD
    nVersion as WORD
    dwFlags as DWORD
    iPixelType as BYTE
    cColorBits as BYTE
    cRedBits as BYTE
    cRedShift as BYTE
    cGreenBits as BYTE
    cGreenShift as BYTE
    cBlueBits as BYTE
    cBlueShift as BYTE
    cAlphaBits as BYTE
    cAlphaShift as BYTE
    cAccumBits as BYTE
    cAccumRedBits as BYTE
    cAccumGreenBits as BYTE
    cAccumBlueBits as BYTE
    cAccumAlphaBits as BYTE
    cDepthBits as BYTE
    cStencilBits as BYTE
    cAuxBuffers as BYTE
    iLayerType as BYTE
    bReserved as BYTE
    dwLayerMask as DWORD
    dwVisibleMask as DWORD
    dwDamageMask as DWORD
end type

type DEVMODE
    dmDeviceName as ASCIIZ * CCHDEVICENAME
    dmSpecVersion as WORD
    dmDriverVersion as WORD
    dmSize as WORD
    dmDriverExtra as WORD
    dmFields as DWORD
    dmOrientation as INTEGER
    dmPaperSize as INTEGER
    dmPaperLength as INTEGER
    dmPaperWidth as INTEGER
    dmScale as INTEGER
    dmCopies as INTEGER
    dmDefaultSource as INTEGER
    dmPrintQuality as INTEGER
    dmColor as INTEGER
    dmDuplex as INTEGER
    dmYResolution as INTEGER
    dmTTOption as INTEGER
    dmCollate as INTEGER
    dmFormName as ASCIIZ * CCHFORMNAME
    dmLogPixels as WORD
    dmBitsPerPel as DWORD
    dmPelsWidth as DWORD
    dmPelsHeight as DWORD
    dmDisplayFlags as DWORD
    dmDisplayFrequency as DWORD
    dmICMMethod as DWORD
    dmICMIntent as DWORD
    dmMediaType as DWORD
    dmDitherType as DWORD
    dmICCManufacturer as DWORD
    dmICCModel as DWORD
    dmPanningWidth as DWORD
    dmPanningHeight as DWORD
end type

declare function zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage as ASCIIZ) as long

declare function GetWindow LIB "USER32.DLL" ALIAS "GetWindow" (byval hWnd as DWORD, byval wCmd as DWORD) as long
declare function RegisterWindowMessage LIB "USER32.DLL" ALIAS "RegisterWindowMessageA" (lpString as ASCIIZ) as long
declare function SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (byval hWnd as DWORD, byval dwMsg as DWORD, byval wParam as DWORD, byval lParam as long) as long
declare function GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () as DWORD
declare function DestroyWindow LIB "USER32.DLL" ALIAS "DestroyWindow" (byval hWnd as DWORD) as long
declare function GetWindowText LIB "USER32.DLL" ALIAS "GetWindowTextA" (byval hWnd as DWORD, lpString as ASCIIZ, byval cch as long) as long
declare function LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" (byval hInstance as DWORD, lpCursorName as ASCIIZ) as DWORD
declare function ChoosePixelFormat LIB "GDI32.DLL" ALIAS "ChoosePixelFormat" (byval hDC as DWORD, pPixelFormatDescriptor as PIXELFORMATDESCRIPTOR) as long
declare function CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" (byval dwExStyle as DWORD, lpClassName as ASCIIZ, lpWindowName as ASCIIZ, byval dwStyle as DWORD, byval x as long, byval y as long, _
                                                                          byval nWidth as long, byval nHeight as long, byval hWndParent as DWORD, byval hMenu as DWORD, byval hInstance as DWORD, lpParam as ANY) as DWORD
declare function DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (byval hWnd as DWORD, byval uMsg as DWORD, byval wParam as DWORD, byval lParam as long) as long
declare function DeleteDC LIB "GDI32.DLL" ALIAS "DeleteDC" (byval hdc as DWORD) as long
declare function DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" (byval hObject as DWORD) as long
declare function DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" (lpMsg as tagMSG) as long
declare function DragQueryFile LIB "SHELL32.DLL" ALIAS "DragQueryFileA" (byval hDrop as DWORD, byval uiFile as DWORD, lpStr as ASCIIZ, byval cch as DWORD) as DWORD
declare function FindClose LIB "KERNEL32.DLL" ALIAS "FindClose" (byval hFindFile as DWORD) as long
declare function FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" (byval hLibModule as DWORD) as long
declare function GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" (byval hInst as DWORD, lpszClass as ASCIIZ, lpWndClass as WNDCLASSEX) as long
declare function GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (byval hwnd as DWORD, lpRect as RECT) as long
declare function GetDC LIB "USER32.DLL" ALIAS "GetDC" (byval hWnd as DWORD) as DWORD
declare function GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () as long
declare function GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" (lpMsg as tagMSG, byval hWnd as DWORD, byval uMsgFilterMin as DWORD, byval uMsgFilterMax as DWORD) as long
declare function GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (byval hModule as DWORD, lpProcName as ASCIIZ) as long
declare function GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" (byval nIndex as long) as long
declare function IsWindowVisible LIB "USER32.DLL" ALIAS "IsWindowVisible" (byval hWnd as DWORD) as long
declare function KillTimer LIB "USER32.DLL" ALIAS "KillTimer" (byval hWnd as DWORD, byval nIDEvent as long) as long
declare function LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" (lpLibFileName as ASCIIZ) as long
declare function RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" (pcWndClassEx as WNDCLASSEX) as WORD
declare function RegisterWindowMessage LIB "USER32.DLL" ALIAS "RegisterWindowMessageA" (lpString as ASCIIZ) as long
declare function ReleaseDC LIB "USER32.DLL" ALIAS "ReleaseDC" (byval hWnd as DWORD, byval hDC as DWORD) as long
declare function SelectObject LIB "GDI32.DLL" ALIAS "SelectObject" (byval hdc as DWORD, byval hObject as DWORD) as DWORD
declare function SetPixelFormat LIB "GDI32.DLL" ALIAS "SetPixelFormat" (byval hDC as DWORD, byval n as long, pcPixelFormatDescriptor as PIXELFORMATDESCRIPTOR) as long
declare function SetRect LIB "USER32.DLL" ALIAS "SetRect" (lpRect as RECT, byval X1 as long, byval Y1 as long, byval X2 as long, byval Y2 as long) as long
declare function SetTimer LIB "USER32.DLL" ALIAS "SetTimer" (byval hWnd as DWORD, byval nIDEvent as long, byval uElapse as DWORD, byval lpTimerFunc as long) as long
declare function ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" (byval hWnd as DWORD, byval nCmdShow as long) as long
declare function SwapBuffers LIB "GDI32.DLL" ALIAS "SwapBuffers" (byval hDC as DWORD) as long
declare function TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" (lpMsg as tagMSG) as long
declare function wglCreateContext LIB "OPENGL32.DLL" ALIAS "wglCreateContext" (byval hdc as DWORD) as DWORD
declare function wglDeleteContext LIB "OPENGL32.DLL" ALIAS "wglDeleteContext" (byval hglrc as DWORD) as long
declare function wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (byval hdc as DWORD, byval hglrc as DWORD) as long
declare function InvalidateRect LIB "USER32.DLL" ALIAS "InvalidateRect" (byval hWnd as DWORD, lpRect as RECT, byval bErase as long) as long
declare function UpdateWindow LIB "USER32.DLL" ALIAS "UpdateWindow" (byval hWnd as DWORD) as long
declare sub PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" (byval nExitCode as long)

declare function glGenLists LIB "opengl32.dll" ALIAS "glGenLists" (byval range as long) as DWORD
declare function glGetError LIB "opengl32.dll" ALIAS "glGetError" () as DWORD
declare function glIsEnabled LIB "opengl32.dll" ALIAS "glIsEnabled" (byval cap as DWORD) as BYTE
declare sub glBindTexture LIB "OPENGL32.DLL" ALIAS "glBindTexture" (byval target as DWORD, byval texture as DWORD)
declare sub glTexParameteri LIB "OPENGL32.DLL" ALIAS "glTexParameteri" (byval target as DWORD, byval pname as DWORD, byval param as long)
declare sub glTexImage2D LIB "OPENGL32.DLL" ALIAS "glTexImage2D" (byval DWORD, byval LONG, byval LONG, byval LONG, byval LONG, byval LONG, byval DWORD, byval DWORD, pixels as ANY)
declare sub glBegin LIB "opengl32.dll" ALIAS "glBegin" (byval mode as DWORD)
declare sub glCallLists LIB "opengl32.dll" ALIAS "glCallLists" (byval n as long, byval ntype as DWORD, lists as ANY)
declare sub glClear LIB "opengl32.dll" ALIAS "glClear" (byval mask as DWORD)
declare sub glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (byval red as SINGLE, byval green as SINGLE, byval blue as SINGLE, byval alpha as SINGLE)
declare sub glColor3f LIB "opengl32.dll" ALIAS "glColor3f" (byval red as SINGLE, byval green as SINGLE, byval blue as SINGLE)
declare sub glColor3ub LIB "opengl32.dll" ALIAS "glColor3ub" (byval red as BYTE, byval green as BYTE, byval blue as BYTE)
declare sub glDeleteLists LIB "opengl32.dll" ALIAS "glDeleteLists" (byval list as DWORD, byval range as long)
declare sub glDeleteTextures LIB "opengl32.dll" ALIAS "glDeleteTextures" (byval n as long, textures as ANY)
declare sub glDisable LIB "opengl32.dll" ALIAS "glDisable" (byval cap as DWORD)
declare sub glEnable LIB "opengl32.dll" ALIAS "glEnable" (byval cap as DWORD)
declare sub glEnd LIB "opengl32.dll" ALIAS "glEnd" ()
declare sub glFlush LIB "opengl32.dll" ALIAS "glFlush" ()
declare sub glFrustum LIB "opengl32.dll" ALIAS "glFrustum" (byval nleft as DOUBLE, byval nright as DOUBLE, byval bottom as DOUBLE, byval top as DOUBLE, byval zNear as DOUBLE, byval zFar as DOUBLE)
declare function glIsTexture LIB "opengl32.dll" ALIAS "glIsTexture" (byval texture as DWORD) as BYTE
declare sub glLightfv LIB "opengl32.dll" ALIAS "glLightfv" (byval light as DWORD, byval pname as DWORD, params as ANY)
declare sub glListBase LIB "opengl32.dll" ALIAS "glListBase" (byval nbase as DWORD)
declare sub glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity" ()
declare sub glMaterialfv LIB "opengl32.dll" ALIAS "glMaterialfv" (byval face as DWORD, byval pname as DWORD, params as ANY)
declare sub glMatrixMode LIB "opengl32.dll" ALIAS "glMatrixMode" (byval mode as DWORD)
declare sub glOrtho LIB "opengl32.dll" ALIAS "glOrtho" (byval nleft as DOUBLE, byval nright as DOUBLE, byval bottom as DOUBLE, byval top as DOUBLE, byval zNear as DOUBLE, byval zFar as DOUBLE)
declare sub glPopAttrib LIB "opengl32.dll" ALIAS "glPopAttrib" ()
declare sub glPopMatrix LIB "opengl32.dll" ALIAS "glPopMatrix" ()
declare sub glPushAttrib LIB "opengl32.dll" ALIAS "glPushAttrib" (byval mask as DWORD)
declare sub glPushMatrix LIB "opengl32.dll" ALIAS "glPushMatrix" ()
declare sub glRasterPos2i LIB "opengl32.dll" ALIAS "glRasterPos2i" (byval x as long, byval y as long)
declare sub glRotated LIB "opengl32.dll" ALIAS "glRotated" (byval angle as DOUBLE, byval x as DOUBLE, byval y as DOUBLE, byval z as DOUBLE)
declare sub glShadeModel LIB "opengl32.dll" ALIAS "glShadeModel" (byval mode as DWORD)
declare sub glTranslated LIB "opengl32.dll" ALIAS "glTranslated" (byval x as DOUBLE, byval y as DOUBLE, byval z as DOUBLE)
declare sub gluLookAt LIB "glu32.dll" ALIAS "gluLookAt" (byval eyex as double, byval eyey as double, byval eyez as double, byval centerx as double, byval centery as double, byval centerz as double, _
                                                         byval upx as double, byval upy as double, byval upz as DOUBLE)
declare sub gluPerspective LIB "glu32.dll" ALIAS "gluPerspective" (byval fovy as double, byval aspect as double, byval zNear as double, byval zFar as DOUBLE)
declare sub glVertex3d LIB "opengl32.dll" ALIAS "glVertex3d" (byval x as DOUBLE, byval y as DOUBLE, byval z as DOUBLE)
declare sub glViewport LIB "opengl32.dll" ALIAS "glViewport" (byval x as long, byval y as long, byval nwidth as long, byval height as long)

type GdiplusStartupInput
    GdiplusVersion as long             ' Must be 1
    DebugEventCallback as long         ' Ignored on free builds
    SuppressBackgroundThread as long   ' FALSE unless you're prepared to call
                                       ' the hook/unhook functions properly
    SuppressExternalCodecs as long     ' FALSE unless you want GDI+ only to use
                                       ' its internal image codecs.
end type

declare function GdiplusStartup LIB "gdiplus.dll" ALIAS "GdiplusStartup" (token as long, inputbuf as GdiplusStartupInput, OPTIONAL byval outputbuf as long) as long
declare function GdiplusShutdown LIB "gdiplus.dll" ALIAS "GdiplusShutdown" (byval token as long) as long

const BBP_RENDER      = 1       '// Render the scene.
const BBP_CREATE      = 2       '// Retrieve Title, Name, Version, Render mode.
const BBP_INIT        = 3       '// Init the OpenGL.
const BBP_SIZE        = 4       '// The size of the control has changed.
const BBP_KEYBOARD    = 5       '// All keyborad message.
const BBP_MOUSE       = 6       '// All mouse messages.
const BBP_DESTROY     = 7       '// Free Up resources.
                      
const BBP_GDIPLUS     = 0       '// GDImage GDIPLUS compatible mode.
const BBP_OPENGL      = 1       '// OpenGL mode.
const BBP_DIRECTX     = 2       '// DirectX mode (for future extension).
                      
const BBP_SUCCESS     = 0
const BBP_ERROR       = -1

type BBPLUGIN                   '// 256 bytes
    Msg          as long        '// The plugin's message (see above constant list).
    ParentWindow as long        '// The parent window handle.
    DC           as long        '// The parent window DC (while in play mode).
    RC           as long        '// The parent OpenGL RC (while in play mode).
    Lpeak        as WORD        '// The left audio channel peak value (while in play mode).
    Rpeak        as WORD        '// The right audio channel peak value (while in play mode).
    Title        as ASCIIZ * 32 '// Plugin's name or title.
    Author       as ASCIIZ * 64 '// Plugin's author name.
    Version      as DWORD       '// LOWRD major, HIWRD minor.
    RenderTo     as long        '// BBP_GDIPLUS, BBP_OPENGL, BBP_DIRECTX.
    BackARGB     as long        '// Default ARGB color background.
    FFTdata      as DWORD       '// DWORD pointer to the FFT() as SINGLE array.
    FFTsize      as WORD        '// Size of the FFT array.

    WinMsg       as long        '// True Windows message.
    wParam       as long        '// wParam
    lParam       as long        '// lParam

    WIMdata      as DWORD       '// DWORD pointer to the wave MM_WIM_DATA.
    MediaLength  as DWORD       '// Media length.
    MediaPos     as DWORD       '// Media pos.

    Reserved     as ASCIIZ * 98 '// Reserved for future extension.
end type

$ANTI                   = "\"
$DOT                    = "."
$BBP_PLUGIN_FOLDER      = "BBplugin\"

const BASS_SYNC_END          = 2
const BASS_SYNC_ONETIME      = &h80000000
const BASS_STREAM_AUTOFREE   = 262144      '// automatically free the stream when it stop/ends
const BASS_STREAM_PRESCAN    = 131072      '// enable pin-point seeking on the MP3/MP2/MP1
const BASS_SAMPLE_3D         = 8           '// 3D functionality enabled
const BASS_STREAM_DECODE     = &H200000    '// don't play the stream, only decode (BASS_ChannelGetData)

' BASS_ChannelGetData flags
const BASS_DATA_AVAILABLE    = 0           '// query how much data is buffered
const BASS_DATA_FFT512       = &H80000000  '// 512 sample FFT
const BASS_DATA_FFT1024      = &H80000001  '// 1024 FFT
const BASS_DATA_FFT2048      = &H80000002  '// 2048 FFT
const BASS_DATA_FFT4096      = &H80000003  '// 4096 FFT

const BASS_DATA_FFT_INDIVIDUAL = &H10      '// FFT flag: FFT for each channel, else all combined
const BASS_DATA_FFT_NOWINDOW   = &H20      '// FFT flag: no Hanning window

const BASS_POS_BYTE        = 0             '// byte position
const BASS_POS_MUSIC_ORDER = 1             '// order.row position, MAKELONG(order,row)
const BASS_ATTRIB_VOL      = 2             '// Channel volume level
const BASS_ACTIVE_PLAYING  = 1             '// Channel is active

const STREAM    = 0
const MUSIC     = 1
const SAMPLE    = 2
const CDAUDIO   = 3
const ACCSTREAM = 4
const WMASTREAM = 5

$BASSMUSICEXT = ".mo3.it.xm.s3m.mtm.mod.umx."
$BASSMP4      = ".m4a.mp4.m4p.m4b"
$BASSAUDIOEXT = ".mp1.mp2.mp3.ogg.wav.aif.wma.bbp.cda.aac" + $BASSMP4 + $BASSMUSICEXT
$CREDIT       = " - Visual plugin by "
$Version      = "Version 2.53"
$ftp          = "ftp://"
$http         = "http://"

declare function BASS_Init LIB "bass.dll" ALIAS "BASS_Init" (byval device as long, byval freq as DWORD, byval flags as DWORD, byval win as DWORD, byval dsguid as DWORD) as long
declare function BASS_ChannelGetLevel LIB "bass.dll" ALIAS "BASS_ChannelGetLevel" (byval nChannel as DWORD) as DWORD
declare function BASS_ChannelPlay LIB "bass.dll" ALIAS "BASS_ChannelPlay" (byval nChannel as DWORD, byval restart as long) as long
declare function BASS_ChannelStop LIB "bass.dll" ALIAS "BASS_ChannelStop" (byval nChannel as DWORD) as long
declare function BASS_ChannelPause LIB "bass.dll" ALIAS "BASS_ChannelPause" (byval nChannel as DWORD) as long
declare function BASS_Free LIB "bass.dll" ALIAS "BASS_Free" () as long
declare function BASS_StreamCreateFile LIB "bass.dll" ALIAS "BASS_StreamCreateFile" (byval mem as long, file as ASCIIZ, byval offset as QUAD, byval length as QUAD, byval flags as DWORD) as long
declare function BASS_MusicLoad LIB "bass.dll" ALIAS "BASS_MusicLoad" (byval mem as long, file as ASCIIZ, byval offset as QUAD, byval length as DWORD, byval flags as DWORD, byval freq as DWORD) as long
declare function BASS_StreamFree LIB "bass.dll" ALIAS "BASS_StreamFree" (byval nChannel as DWORD) as long
declare function BASS_MusicFree LIB "bass.dll" ALIAS "BASS_MusicFree" (byval nChannel as DWORD) as long
declare function BASS_ChannelSetSync LIB "bass.dll" ALIAS "BASS_ChannelSetSync" (byval nChannel as DWORD, byval pbType as long, byval param as QUAD, byval proc as long, byval USER as long) as long
declare function BASS_SetVolume LIB "bass.dll" ALIAS "BASS_SetVolume" (byval UseVolume as SINGLE) as long
declare function BASS_ChannelGetPosition LIB "bass.dll" ALIAS "BASS_ChannelGetPosition" (byval nChannel as DWORD, byval nMode as DWORD) as DWORD
declare function BASS_ChannelSetPosition LIB "bass.dll" ALIAS "BASS_ChannelSetPosition" (byval nChannel as DWORD, byval nPos as QUAD) as long
declare function BASS_ChannelGetLength LIB "bass.dll" ALIAS "BASS_ChannelGetLength" (byval nChannel as DWORD, byval nMode as DWORD) as DWORD
declare function BASS_MusicGetOrders LIB "bass.dll" ALIAS "BASS_MusicGetOrders" (byval nChannel as DWORD) as DWORD
declare function BASS_ErrorGetCode LIB "bass.dll" ALIAS "BASS_ErrorGetCode"() as long
declare function BASS_ChannelGetData LIB "bass.dll" ALIAS "BASS_ChannelGetData" (byval nChannel as DWORD, byval buffer as DWORD, byval nlength as long) as long
'declare function BASS_WMA_StreamCreateFile LIB "basswma.dll" ALIAS "BASS_WMA_StreamCreateFile" (byval mem as long, file as ASCIIZ, byval offset as QUAD, byval length as QUAD, byval flags as DWORD) as long
'declare function BASS_WMA_StreamCreateFileAuth LIB "basswma.dll" ALIAS "BASS_WMA_StreamCreateFileAuth" (byval mem as long, file as ASCIIZ, byval offset as QUAD, byval length as QUAD, byval flags as DWORD, zUser as ASCIIZ, zPath as ASCIIZ) as long
declare function TAGS_Read LIB "BassTags.dll" ALIAS "TAGS_Read" (byval nChannel as DWORD, zFmt as ASCIIZ) as long
declare function BASS_CD_StreamCreateFile LIB "basscd.dll" ALIAS "BASS_CD_StreamCreateFile" (file as ASCIIZ, byval flags as DWORD) as long
declare function BASS_ChannelBytes2Seconds LIB "bass.dll" ALIAS "BASS_ChannelBytes2Seconds" (byval nChannel as DWORD, byval nPos as QUAD) as DOUBLE
declare function BASS_ChannelSetAttribute LIB "bass.dll" ALIAS "BASS_ChannelSetAttribute" (byval nChannel as DWORD, byval nAtteib as DWORD, byval nValue as SINGLE) as long
declare function BASS_ChannelIsActive LIB "bass.dll" ALIAS "BASS_ChannelIsActive" (byval nChannel as DWORD) as DWORD

'// AAC support
' Additional BASS_SetConfig options
const BASS_CONFIG_MP4_VIDEO = &H10700  '// play the audio from MP4 videos
const BASS_TAG_MP4          = 7        '// MP4/iTunes metadata
const BASS_AAC_DOWNMATRIX   = &H400000 '// downmatrix to stereo
const BASS_CTYPE_STREAM_AAC = &H10B00  '// BASS_CHANNELINFO type
const BASS_CTYPE_STREAM_MP4 = &H10B01  '// BASS_CHANNELINFO type
declare function BASS_AAC_StreamCreateFile LIB "Bass_AAC.dll" ALIAS "BASS_AAC_StreamCreateFile" (byval mem as long, file as ASCIIZ, byval offset as QUAD, byval length as QUAD, byval flags as DWORD) as DWORD
declare function BASS_MP4_StreamCreateFile LIB "Bass_AAC.dll" ALIAS "BASS_MP4_StreamCreateFile" (byval mem as long, file as ASCIIZ, byval offset as QUAD, byval length as QUAD, byval flags as DWORD) as DWORD

declare function prototype_wglSwapIntervalEXT( byval number as long ) as long
declare function wglGetProcAddress LIB "opengl32.dll" ALIAS "wglGetProcAddress" (lpStr as ASCIIZ) as long
declare function DwmIsCompositionEnabled () as long
declare sub      apiSleep LIB "KERNEL32.DLL" ALIAS "Sleep" (byval dwMilliseconds as DWORD)
declare function wglSwapBuffers LIB "OPENGL32.DLL" ALIAS "wglSwapBuffers" (byval hdc as DWORD) as DWORD

'// global definitions
const XMIN_SIZE      = 800
const YMIN_SIZE      = 600
const ID_VISUAL      = -1
const VISUAL_TIMER   = 2

global glRC, gnCodeID, gnBassInitDone, gnMediaType, gnAudioPause as long
global gnAudioChannel, gnMediaLength, gnMediaPos as DWORD
global gzAudioFile as ASCIIZ * MAX_PATH
global gnMain, gnParent as DWORD
global WM_ZWPNOTIFICATION as long

function GdipStart() as long
    local nRet, hGDIplus as long
    '// Load GDIPLUS
    DIM GpInput as GdiplusStartupInput
    GpInput.GdiplusVersion = 1
    nRet = 0: hGDIplus = 0
    if (GdiplusStartup(hGDIplus, GpInput) = 0) then nRet = hGDIplus
    function = nRet
end function

sub GdipEnd(byval hGDIplus as long)
    if (hGDIplus) then GdiplusShutdown(hGDIplus)
end sub

function BBP_ProcHandle(byval hProc as DWORD, byval RW as long) as DWORD
    static WasHproc as DWORD
    if (RW) then WasHproc = hProc
    function = WasHproc
end function
'// Detached plugin
sub BBP_Detached(byval hWnd as long, byref hLib as DWORD)
    local BBP as BBPLUGIN
    if (hLib) then
       BBP.Msg = BBP_DESTROY
       BBP.ParentWindow = hWnd
       BBP_Plugin(BBP)

'      // use brute force to delete any existing texture
       local K, Tmax as long
       Tmax = 32
       REDIM DT(1 TO Tmax) as local LONG
       FOR K = 1 TO Tmax: DT(K) = K: NEXT
       glDeleteTextures(K, DT(1))

       BBP_ProcHandle(0, 1): FreeLibrary(hLib): hLib = 0
    end if
end sub
function BBP_ActivePlugin(byval sPluginName as string, byval RW as long) as string
    static sWasPluginName as string
    if (RW) then sWasPluginName = sPluginName
    function = sWasPluginName
end function
'// Load/unload plugin DLL to/from memory
function BBP_LoadPlugin(byval hWnd as long, zPlugin as ASCIIZ) as long
    static hLib as DWORD, sLastPlugin as string
    local nDone as long
    local hProc as DWORD
    if (len(zPlugin) and zPlugin <> sLastPlugin) then
       if (IsFile(zPlugin)) then
          BBP_Detached(hWnd, hLib)
          hLib = LoadLibrary(zPlugin)
          if (hLib) then
             hProc = GetProcAddress(hLib, "BBProc")
             if (hProc) then
                BBP_ProcHandle(hProc, 1)
                sLastPlugin = zPlugin
                BBP_ActivePlugin(sLastPlugin, 1)
                '// Reset plugin to default
                BBP_Reset()
                nDone = -1
             end if
          end if
       end if
    elseif len(zPlugin) = 0 then
       BBP_Detached(hWnd, hLib)
    end if
    function = nDone
end function
'// Send/recept message to/from plugin
function BBP_Plugin(byref BBP as BBPLUGIN) as long
    local hProc as DWORD, nRet as long
    nRet = BBP_ERROR
    if (glRC) then
       hProc = BBP_ProcHandle(0, 0): if (hProc) then CALL DWORD hProc USING BBP_Plugin(BBP) TO nRet
    end if
    function = nRet
end function
''// Return full qualified path to the plugin folder
'function BBP_Path() as string
'    function = EXE.Path$ + $BBP_PLUGIN_FOLDER
'end function

function LoadDWM () as long
    static hLib as DWORD, nChecked as long
    if (nChecked = 0) then nChecked = -1: hLib = LoadLibrary ("dwmapi.dll")
    function = hLib
end function

function zDwmIsCompositionEnabled () as long
    local nRet as long, hLib as DWORD
    static hProc as DWORD
    hLib = LoadDWM()
    if (hLib) then
       if (hProc = 0) then hProc = GetProcAddress(hLib, "DwmIsCompositionEnabled")
       if (hProc) then
          CALL DWORD hProc USING DwmIsCompositionEnabled() TO nRet
          if (nRet) then function = -1
       end if
    end if
end function

sub BBP_Reset ()
    local BBP as BBPLUGIN
    BBP.Msg = BBP_CREATE
    BBP_Plugin(BBP)
    if (BBP.RenderTo = BBP_OPENGL) then
       glDisable(GL_BLEND)
       glDisable(GL_TEXTURE_2D)
       glDisable(GL_DEPTH_TEST)
       glDisable(GL_LIGHT0)
       glDisable(GL_LIGHT1)
       glDisable(GL_LIGHT2)
       glDisable(GL_LIGHT3)
       glDisable(GL_LIGHT4)
       glDisable(GL_LIGHT5)
       glDisable(GL_LIGHT6)
       glDisable(GL_LIGHT7)
       glDisable(GL_LIGHTING)
       glDisable(GL_COLOR_MATERIAL)
       glDisable(GL_ALPHA_TEST)
       glDisable(GL_NORMALIZE)

       local ptr_wglSwapIntervalEXT as DWORD
       ptr_wglSwapIntervalEXT = wglGetProcAddress("wglSwapIntervalEXT")
       if (ptr_wglSwapIntervalEXT) then
          if (zDwmIsCompositionEnabled()) then
             CALL DWORD ptr_wglSwapIntervalEXT USING prototype_wglSwapIntervalEXT(0)
          else
             CALL DWORD ptr_wglSwapIntervalEXT USING prototype_wglSwapIntervalEXT(1)
          end if
       end if

       glGetError()

    end if
end sub

function BassChannelGetLevel () as long
    LOCAl nRet as long
    if (gnAudioPause = 0) then
       if (gnAudioChannel) then
          nRet = BASS_ChannelGetLevel(gnAudioChannel)
       end if
    end if
    function = nRet
end function

function BassChannelGetData () as DWORD
    DIM fft(255) as static SINGLE
    local nRet as long
    RESET fft()
    if (gnAudioPause = 0) then
       if (gnAudioChannel) then
          nRet = BASS_ChannelGetData(gnAudioChannel, VARPTR(fft(0)), BASS_DATA_FFT512)
       end if
    end if
    function = VARPTR(fft(0))
end function

function BassFree () as long
    if (gnBassInitDone) then function = BASS_Free(): gnBassInitDone = 0
end function

function BassCloseChannel () as long
    local nRet as long
    if (gnAudioChannel) then
       if (gnMediaType = MUSIC) then
          nRet = BASS_MusicFree(gnAudioChannel)
       else
          nRet = BASS_StreamFree(gnAudioChannel)
       end if
       gnAudioChannel = 0: gnMediaType = 0
    end if
    function = nRet
end function

function BassInit (byval hWnd as long) as long
    if (gnBassInitDone = 0) then gnBassInitDone = BASS_Init(1, 44100, 0, hWnd, 0)
    function = gnBassInitDone
end function

sub BassStreamEllapsed(nSync as long, nChannel as long, nData as long, nUser as long)
    BassCloseChannel()
    gnAudioPause = 0
    SendMessage(gnParent, WM_ZWPNOTIFICATION, NM_AUDIOCOMPLETION, 0)
end sub

function BassChannelPlay(byval hWnd as long) as long
    local So, IsUrl as long, sLowExt as string

    BassCloseChannel()

    if (BassInit(hWnd)) then

       if (INSTR(LCASE$(gzAudioFile), $ftp) OR INSTR(LCASE$(gzAudioFile), $http)) then IsUrl = -1

       So = INSTR(-1, gzAudioFile, $DOT)
       if (So) then
           if (INSTR($BASSMUSICEXT, LCASE$(MID$(gzAudioFile, So)) + $DOT)) then
               gnMediaType = MUSIC
               gnAudioChannel = BASS_MusicLoad(0, gzAudioFile, 0, 0, BASS_STREAM_PRESCAN OR BASS_STREAM_AUTOFREE, 0)
           else
               gnMediaType = STREAM
               gnAudioChannel = BASS_StreamCreateFile(0, gzAudioFile, 0, 0, BASS_STREAM_AUTOFREE)
           end if
       end if

       if (gnAudioChannel) then
          BASS_ChannelSetSync(gnAudioChannel, BASS_SYNC_END OR BASS_SYNC_ONETIME, 0, CODEPTR(BassStreamEllapsed), 0)

          function = BASS_ChannelPlay(gnAudioChannel, 0)

          '////////////////////////////////////////

          local nScanChannel as long
          nScanChannel = BASS_StreamCreateFile(0, gzAudioFile, 0, 0, BASS_STREAM_DECODE)

          '////////////////////////////////////////

          gnAudioPause = 0
       else
          BassStreamEllapsed(0, 0, 0, 0)
       end if
    end if
end function

function BassChannelGetWimData () as DWORD
    DIM fft(255) as static SINGLE
    local nRet as long
    RESET fft()
    if (gnAudioPause = 0) then
       if (gnAudioChannel) then
           nRet = BASS_ChannelGetData(gnAudioChannel, VARPTR(fft(0)), 1024)
       end if
    end if
    function = VARPTR(fft(0))
end function

'function BassChannelPause () as long
'    function = BASS_ChannelPause(gnAudioChannel)
'    gnAudioPause = 1
'end function

'function BassChannelResume () as long
'    function = Bass_Channelplay(gnAudioChannel, 0)
'    gnAudioPause = 0
'end function

'function BassChannelGetPos() as DWORD
'    if (gnAudioChannel) then
'       function = BASS_ChannelGetPosition(gnAudioChannel, 0)
'    end if
'end function

'function BassChannelGetLength() as DWORD
'    if gnAudioChannel then
'       function = BASS_ChannelGetLength(gnAudioChannel, 0)
'    end if
'end function

'function BassSetChannelVolume(byval nVolume as long) as long
'    BASS_ChannelSetAttribute(gnAudioChannel, BASS_ATTRIB_VOL, nVolume / 100)
'end function

'function BassChannelSetPos (byval nPos as DWORD) as long
'    if (gnAudioChannel) then
'       function = BASS_ChannelSetPosition(gnAudioChannel, MAK(QUAD, nPos, 0))
'    end if
'end function

function SolvePeak (byval nValue as long, byval nTotal as long) as long
    local nRet as long
    nRet = 0: if nTotal then nRet = (nValue * 100) \ nTotal
    function = nRet
end function

sub ResizeGLwindow (byval hWnd as long)
    local rc as RECT
    GetClientRect(hWnd, rc)
    glViewport(0, 0, rc.nRight, rc.nBottom)

    local BBP as BBPLUGIN
    BBP.Msg          = BBP_SIZE
    BBP.ParentWindow = hWnd
    BBP_Plugin(BBP)
end sub

function zSetupPixelFormat (byval hDC as long) as long
    local pfd as PIXELFORMATDESCRIPTOR
    local pixelformat as long
    local lRet as long

    lRet = -1

    pfd.nSize      = SIZEOF(pfd)
    pfd.nVersion   = 1
    pfd.dwFlags    = PFD_DRAW_TO_WINDOW OR PFD_SUPPORT_OPENGL OR PFD_DOUBLEBUFFER OR PFD_DRAW_TO_BITMAP
    pfd.iPixelType = PFD_TYPE_RGBA

    pfd.cColorBits = 32
    pfd.cDepthBits = 32

    pixelformat = ChoosePixelFormat(hDC, pfd)

    if (pixelformat) then
       if (SetPixelFormat(hDC, pixelformat, pfd) = 0) then lRet = 0
    else
       lRet = 0
    end if

    function = lRet
end function

function InitOpenGL (byval hWnd as long, zPlugin as ASCIIZ) as long
    local glDC, nRet as long, BBP as BBPLUGIN
    glDC = GetDC(hWnd)

    nRet = 0
    if (zSetupPixelFormat(glDC)) then
       glRC = wglCreateContext(glDC)
       if (glRC) then
          if (wglMakeCurrent(glDC, glRC)) then

             '// Load default plugin
             BBP_LoadPlugin(hWnd, zPlugin)
             BBP.Msg          = BBP_INIT
             BBP.ParentWindow = hWnd
             BBP.DC           = glDC
             BBP.RC           = glRC
             BBP.BackARGB     = 0
             BBP.FFTsize      = 256
             if (BBP_Plugin(BBP) = BBP_SUCCESS) then
                 ResizeGLwindow(hWnd)
                 nRet = -1
             end if
          end if
       end if
    end if
    ReleaseDC(hWnd, glDC)
    function = nRet
end function

sub RenderOpenGL (byval hWnd as long)

    if (IsWindowVisible(hWnd) = 0) then EXIT sub

    local nLevel, nLpeak, nRpeak, glDC as long
    local BBP as BBPLUGIN

    glDC = GetDC(hWnd)

    if (glRC) then

       nLevel = BassChannelGetLevel()

       nLpeak = SolvePeak(LO(WORD, nLevel), 128)
       nRpeak = SolvePeak(HI(WORD, nLevel), 128)

       BBP.Msg          = BBP_RENDER
       BBP.ParentWindow = hWnd
       BBP.DC           = glDC
       BBP.RC           = glRC
       BBP.Lpeak        = nLpeak
       BBP.Rpeak        = nRpeak
       BBP.BackARGB     = 0
       BBP.FFTdata      = BassChannelGetData()
       BBP.FFTsize      = 256
       BBP.MediaLength  = gnMediaLength
       BBP.MediaPos     = gnMediaPos
       BBP.WIMdata      = BassChannelGetWimData()

       BBP_PLUGIN(BBP)

       '// Refresh display
       SwapBuffers(glDC)

       InvalidateRect(hWnd, byval NULL, 0)
       UpdateWindow(hWnd)

    end if
    ReleaseDC(hWnd, glDC)

end sub

function GetCTLText (byval hCTRL as long) as string
    local nLength as long, szText as ASCIIZ * 4096
    nLength = GetWindowText(hCTRL, szText, SIZEOF(szText))
    if (nLength) then function = UCASE$(LEFT$(szText, nLength))
end function

'// Main window procedure
function WndProc (byval hWnd as long, byval Msg as long, byval wParam as long, byval lParam as long) as long
    local sMessage, sParam, sCodeID as string

    select case long (Msg)

    case WM_WINDOWPOSCHANGING:
         if (gnParent) then
             local wp as WINDOWPOS PTR
             wp = lParam
             @wp.hWndInsertAfter = GetWindow(gnParent, 2)
             function = 0: EXIT function
         end if

    case WM_SETTEXT:
         '// Let Windows do its default work first.
         DefWindowProc(hWnd, Msg, wParam, lParam)
         '// Read file name
         sMessage = GetCTLText(hWnd)
         sCodeID = PARSE$(sMessage, 3)
         sParam = PARSE$(sMessage, 2): if (len(sParam)) then sMessage = PARSE$(sMessage, 1)
         if (sMessage = "DESTROY") then
            DestroyWindow(hWnd)
         elseif (sMessage = "PLAY") then
            if (IsFile(sParam)) then
               gzAudioFile = sParam
               BassChannelPlay(hWnd)
            end if
         elseif (sMessage = "PARENT") then
            gnParent = VAL(sParam)
            gnCodeID = VAL(sCodeID)
         elseif (sMessage = "STOP") then
            BassCloseChannel()
         elseif (sMessage = "PLUGIN") then
            local BBP as BBPLUGIN
            if (BBP_LoadPlugin(hWnd, (sParam))) then ' Make sure that a different plugin has been selected
               BBP.Msg          = BBP_INIT
               BBP.ParentWindow = hWnd
               BBP.DC           = GetDC(BBP.ParentWindow)
               BBP.RC           = glRC
               BBP.BackARGB     = 0

               if (BBP_Plugin(BBP) = BBP_SUCCESS) then
                  ResizeGLwindow(hWnd)
               end if
               ReleaseDC(BBP.ParentWindow, BBP.DC)
            end if
         end if

    case WM_CLOSE:
         BassCloseChannel()

    case WM_SIZE:
         if (glRC) then
            ResizeGLwindow(hWnd)
            RenderOpenGL(hWnd)
         end if

    case WM_DESTROY:
         '// Detached active plugin
         BBP_LoadPlugin(hWnd, "")

         PostQuitMessage(0)
         function = 0: EXIT function

    case WM_TIMER:
         if (wParam = VISUAL_TIMER) then
            RenderOpenGL(hWnd)
            function = 0: EXIT function
         end if

    end select

    function = DefWindowProc(hWnd, Msg, wParam, lParam)

end function

'// Main entry point
function WINMAIN (byval hInstance     as long, _
                  byval hPrevInstance as long, _
                  byval lpCmdLine     as ASCIIZ PTR, _
                  byval iCmdShow      as long) as long

    local Msg         as tagMsg
    local wcx         as WndClassEx
    local zClass      as ASCIIZ * 80
    local dwExStyle   as DWORD
    local dwStyle     as DWORD
    local rc          as RECT
    local x           as long
    local y           as long
    local sPlugin     as string

    local IsInitialized        as long
    local hGDIplus             as long ' GDIPLUS

    zClass = "ZWALLPAPER"

    wcx.cbSize = SIZEOF(wcx)
    IsInitialized = GetClassInfoEx(hInstance, zClass, wcx)
    if IsInitialized    = 0 then
       wcx.cbSize        = SIZEOF(wcx)
       wcx.style         = CS_HREDRAW OR CS_VREDRAW
       wcx.lpfnWndProc   = CODEPTR(WndProc)
       wcx.cbWndExtra    = 0
       wcx.hInstance     = hInstance
       wcx.hIcon         = 0
       wcx.hCursor       = LoadCursor(0, byval IDC_ARROW)
       wcx.hbrBackground = 0
       wcx.lpszMenuName  = 0
       wcx.lpszClassName = VARPTR(zClass)
       wcx.hIconSm       = 0
       if (RegisterClassEx(wcx)) then IsInitialized = -1
    end if

    if (IsInitialized) then

       '// Init GDIPLUS
       hGDIplus = GdipStart()

       x = MAX&((GetSystemMetrics(SM_CXSCREEN) - XMIN_SIZE) \ 2, 0)
       y = -2000

       '// Create the window
       gnMain = CreateWindowEx(WS_EX_TOOLWINDOW, _   ' Extended Style For The Window
                              zClass, _               ' Class Name
                              zClass, _               ' Window Title
                              WS_POPUP, _            ' Defined Window Style
                              x, y, _                 ' Window Position
                              XMIN_SIZE, _           ' Window Width
                              YMIN_SIZE, _           ' Window Height
                              0, _                    ' No Parent Window
                              0, _                    ' No Menu
                              hInstance, _            ' Instance
                              byval 0)                ' Dont Pass Anything To WM_CREATE

       if (gnMain) then

          '// Register the private message to communicate with the parent application
          WM_ZWPNOTIFICATION = RegisterWindowMessage("ZWPnotification")

          sPlugin = COMMAND$
          if (PARSECOUNT(sPlugin) = 2) then
             gnParent = VAL(PARSE$(sPlugin, 2))
             sPlugin = PARSE$(sPlugin, 1)
          end if

          if (IsFile(sPlugin)) then

             '// Load plugin based on command line.
             InitOpenGL(gnMain, (sPlugin))

             SetTimer(gnMain, VISUAL_TIMER, 0, 0) '// 66 FPS

             while (GetMessage(Msg, 0, 0, 0))
                 TranslateMessage(Msg)
                 DispatchMessage(Msg)
             wend

             KillTimer(gnMain, VISUAL_TIMER)

             BassCloseChannel()
             BassFree()

             if (glRC) then
                wglMakeCurrent(0, 0)
                wglDeleteContext(glRC): glRC = 0
             end if

             function = msg.wParam
          end if
       end if

       '// UNLOAD GDIPLUS
       GdipEnd(hGDIplus)

    end if

end function

